unit invisiblefrm;

interface

uses
  {$IFNDEF FPC}Windows, xpman, {$ELSE}LResources, FPImage, GraphType, IntfGraphics, {$ENDIF}SysUtils,
  Variants, Classes, Graphics, Controls, Forms, Dialogs, fe_flashplayer, ExtCtrls, StdCtrls, Buttons;

type

  { TfrmInvisible }

  TfrmInvisible = class(TForm)
    BitBtn1: TBitBtn;
    OpenDialog1: TOpenDialog;
    feFlashList1: TfeFlashList;
    feFlashPlayerComp1: TfeFlashPlayerComp;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Image1: TImage;
    procedure BitBtn1Click(Sender: TObject);
    procedure feFlashPlayerComp1Paint(ASender: TObject;
      const ARect: TRect);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmInvisible: TfrmInvisible;

implementation

{$R *.dfm}

procedure TfrmInvisible.BitBtn1Click(Sender: TObject);
begin
  if Opendialog1.Execute then
  begin
    feFlashPlayerComp1.LoadMovie(Opendialog1.FileName);
  end;
end;

procedure TfrmInvisible.feFlashPlayerComp1Paint(ASender: TObject;
  const ARect: TRect);
begin
  Label2.Tag := Label2.Tag + 1;
  Label2.Caption := 'OnPaint Event ' + IntToStr(Label2.Tag) + ' Update rect: ' + IntToStr(ARect.Left) + ',' +
    IntToStr(ARect.Top) + ',' + IntToStr(ARect.Right) + ',' + IntToStr(ARect.Bottom);
end;

procedure TfrmInvisible.Button1Click(Sender: TObject);
var
  B: TBitmap;
  i: integer;
  {$IFDEF FPC}
  IntfImage: TLazIntfImage;
  ScanLineImage: TLazIntfImage;
  ImgFormatDescription: TRawImageDescription;
  {$ENDIF}
begin
  B := TBitmap.Create;
  B.HandleType := bmDIB;
  B.PixelFormat := pf32Bit;
  B.Width := feFlashPlayerComp1.Width;
  B.Height := feFlashPlayerComp1.Height;

  {$IFNDEF FPC}
  // copy bits
  for i := 0 to B.Height - 1 do
    Move(feFlashPlayerComp1.Scanline[i]^, B.Scanline[i]^, feFlashPlayerComp1.Width * 4);
  {$ELSE}
  ScanLineImage := TLazIntfImage.Create(0,0);
  ImgFormatDescription.Init_BPP32_B8G8R8A8_BIO_TTB(B.Width, B.Height);
  ScanLineImage.DataDescription := ImgFormatDescription;

  for i := 0 to ScanLineImage.Height-1 do
    Move(feFlashPlayerComp1.Scanline[i]^, ScanLineImage.GetDataLineStart(i)^, B.Width * 4);

  // create IntfImage with the format of the current LCL interface
  IntfImage := B.CreateIntfImage;
  // convert the content from the very specific to the current format
  IntfImage.CopyPixels(ScanLineImage);
  B.LoadFromIntfImage(IntfImage);

  ScanLineImage.Free;
  IntfImage.Free;
  {$ENDIF}

  Image1.Picture.Assign(B);
  B.Free;
end;

end.
